/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { Base, runOn, markType, INotifyPropertyChanged_$type, PropertyChangedEventArgs, enumGetBox } from "./type";
import { Size } from "./Size";
import { ElevationHelper } from "./ElevationHelper";
import { CornerRadius } from "./CornerRadius";
import { NativeUI } from "./NativeUI";
import { PopupPointerPosition_$type } from "./PopupPointerPosition";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "./AnimationKeyFrameEffect";
import { AnimationKeyFrameEffectTiming } from "./AnimationKeyFrameEffectTiming";
import { KeyFrameAnimationFactory } from "./KeyFrameAnimationFactory";
import { Rect } from "./Rect";
import { PopupAnimationType_$type } from "./PopupAnimationType";
import { stringFormat } from "./stringExtended";
import { isNaN_, truncate } from "./number";
import { stringEmpty } from "./string";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { MouseEventArgs } from "./MouseEventArgs";
import { FocusEventArgs } from "./FocusEventArgs";
import { List$1 } from "./List$1";
import { AnimationKeyFrameProperty } from "./AnimationKeyFrameProperty";
import { TranslateTransform } from "./TranslateTransform";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { PopupAnimation } from "./PopupAnimation";
import { DeviceUtils } from "./DeviceUtils";
import { PopupVisualModelExport } from "./PopupVisualModelExport";
import { AppearanceHelper } from "./AppearanceHelper";
import { BrushUtil } from "./BrushUtil";
/**
 * @hidden
 */
export let PopupView = /*@__PURE__*/ (() => {
    class PopupView extends Base {
        constructor() {
            super(...arguments);
            this.ad = null;
            this.f = null;
            this.al = null;
            this.ak = null;
            this.aj = null;
            this.ag = null;
            this.ai = null;
            this.ah = null;
            this.an = null;
            this.s = 0;
            this.t = 0;
            this.r = 0;
            this.l = false;
            this.u = 0;
            this.p = 0;
            this.q = 0;
            this.n = 0;
            this.o = 0;
            this.af = null;
            this.am = null;
            this.bk = new Size(1, 0, 0);
            this.k = true;
            this.m = false;
        }
        get ac() {
            return this.g.a1;
        }
        get z() {
            return this.ac / 2;
        }
        get y() {
            return this.ac * 1.414;
        }
        get x() {
            return this.y / 2;
        }
        get aa() {
            return (this.bl.width / 2 - this.z);
        }
        get ab() {
            return (this.bl.height / 2 - this.z);
        }
        get g() {
            return this.f;
        }
        get ae() {
            return this.ad;
        }
        a3() {
            this.al.setStyleProperty("height", "0%");
            this.al.setStyleProperty("width", "0%");
            this.ag = this.ad.createElement("div");
            this.ag.setStyleProperty("position", "absolute");
            this.ag.setStyleProperty("z-index", "10000");
            this.ai = this.ad.createElement("div");
            this.ai.setStyleProperty("height", 20 * 1.414 / 2 + "px");
            this.ah = this.ad.createElement("div");
            this.ah.setStyleProperty("position", "relative");
            this.ah.setStyleProperty("width", this.ac + "px");
            this.ah.setStyleProperty("height", this.ac + "px");
            this.ah.setStyleProperty("z-index", "1");
            this.ah.setStyleProperty("clip-path", stringFormat("path(\"M0,0l{0},{0}l0,-{0}l-{0},0Z\")", this.ac));
            this.ai.append(this.ah);
            this.ak = this.ad.createElement("div");
            this.ak.setStyleProperty("position", "relative");
            this.ak.setStyleProperty("overflow", "hidden");
            this.ak.setAttribute("key", "popupContentAreaOuter");
            this.bb(this.g.aq);
            this.ag.listen("mouseenter", runOn(this, this.a4));
            this.ag.listen("mouseleave", runOn(this, this.a5));
            this.ag.listen("focusin", runOn(this, this.a1));
            this.ag.listen("focusout", runOn(this, this.a2));
            this.aj = this.ad.createElement("div");
            this.aj.setAttribute("key", "popupContentAreaInner");
            this.ak.append(this.aj);
            this.ag.append(this.ak);
        }
        bh() {
            let a = this.g;
            let b = ElevationHelper.e(a.a4, a.cm, a.cl, a.ck);
            this.ak.setStyleProperty("box-shadow", b);
        }
        bf() {
            if (this.g.cn != null) {
                this.ak.setStyleProperty("background-color", this.g.cn._fill);
                this.ah.setStyleProperty("background-color", this.g.cn._fill);
            }
            if (this.g.cr != null) {
                this.ah.setStyleProperty("background-color", this.g.cr._fill);
            }
        }
        bg() {
            if (!isNaN_(this.g.ay)) {
                NativeUI.n(this.ak, new CornerRadius(0, this.g.ay));
            }
        }
        bi() {
            if (null == this.al) {
                return;
            }
            this.bh();
            this.bf();
            this.bg();
        }
        a4(a) {
            this.g.b5();
        }
        a5(a) {
            this.g.b6();
        }
        a1(a) {
            this.g.b3();
        }
        a2(a) {
            this.g.b4(a.originalEvent.relatedTarget);
        }
        aq() {
            if (null != this.ag) {
                this.bi();
                this.ak.setStyleProperty("height", "0px");
                let a = this.ag.getNativeElement();
                if (false == this.l) {
                    this.ai.remove();
                    if (this.g.as) {
                        let b = this.g.s();
                        if (b == 1) {
                            this.ag.setStyleProperty("display", "block");
                            let c = this.ag.getNativeElement();
                            let d = this.ai.getNativeElement();
                            let e = this.ak.getNativeElement();
                            c.insertBefore(d, e);
                        }
                        else if (b == 2) {
                            this.ag.setStyleProperty("display", "block");
                            this.ag.append(this.ai);
                        }
                        else if (b == 3) {
                            this.ag.setStyleProperty("display", "flex");
                            let f = this.ag.getNativeElement();
                            let g = this.ai.getNativeElement();
                            let h = this.ak.getNativeElement();
                            f.insertBefore(g, h);
                            this.ai.setStyleProperty("height", "unset");
                            this.ai.setStyleProperty("width", 20 * 1.414 / 2 + "px");
                        }
                        else if (b == 4) {
                            this.ag.setStyleProperty("display", "flex");
                            this.ag.append(this.ai);
                            this.ai.setStyleProperty("height", "unset");
                            this.ai.setStyleProperty("width", 20 * 1.414 / 2 + "px");
                        }
                    }
                    document.body.appendChild(a);
                    this.l = true;
                    if (this.k) {
                        this.ay();
                    }
                }
            }
        }
        ar(a, b) {
            this.ag.setStyleProperty("top", PopupView.ao(a.f));
            this.ak.setStyleProperty("height", PopupView.ap(a.h));
            this.ag.setStyleProperty("top", PopupView.ap(b.b));
            this.aj.setStyleProperty("opacity", "1");
            this.aj.setStyleProperty("transform", stringEmpty());
            this.u = 0;
            if (this.m) {
                this.be();
            }
            if (this.g.av) {
                this.am.observe(this.af.getNativeElement());
            }
            else {
                this.am.disconnect();
            }
            if (this.g.an) {
                this.bc(this.g.ar);
            }
            return {
                p0: a,
                p1: b
            };
        }
        as(a) {
            this.u = a;
            if (this.g.an) {
                this.bc(false);
            }
            if (this.g.as) {
                let b = 0;
                let c = 0;
                switch (this.g.s()) {
                    case 3:
                        b = -135;
                        c = this.z;
                        this.s = c;
                        this.t = a / 2 - this.z;
                        break;
                    case 4:
                        b = 45;
                        c = -this.z;
                        this.s = c;
                        this.t = a / 2 - this.z;
                        break;
                }
                this.r = b;
                this.ah.setStyleProperty("transform", "translate(" + this.s + "px, " + this.t + "px) rotate(" + this.r + "deg)");
            }
        }
        a9() {
            if (null != this.ag && this.l) {
                let a = this.ag.getNativeElement();
                document.body.removeChild(a);
                this.l = false;
            }
        }
        at(a) {
            this.af = a;
            this.aj.append(this.af);
            this.am = new ResizeObserver(runOn(this, this.a0));
        }
        a0(a) {
            if (this.l) {
                if (this.g.ao() && this.g.o == 0) {
                    return;
                }
                this.g.b0();
            }
        }
        j(a) {
            let b = this.ag.getNativeElement();
            return b.contains(a);
        }
        a8(a) {
            this.af = null;
            this.am.disconnect();
            this.am = null;
            a.remove();
        }
        d(a) {
            return new AnimationKeyFrameEffect(0, this.aj, 0, null, a);
        }
        e(a) {
            return new AnimationKeyFrameEffect(0, this.ak, 0, null, a);
        }
        av() {
            if (KeyFrameAnimationFactory.h == null) {
                KeyFrameAnimationFactory.h = this.ae;
            }
        }
        c(a) {
            return new AnimationKeyFrameEffect(0, this.ag, 0, null, a);
        }
        b(a) {
            return new AnimationKeyFrameEffect(0, this.ak, 0, null, a);
        }
        a(a) {
            return new AnimationKeyFrameEffect(0, this.ag, 0, null, a);
        }
        i() {
            return 12;
        }
        h() {
            return 11;
        }
        get bl() {
            if (this.k) {
                this.ay();
            }
            return this.bk;
        }
        v(a, b, c) {
            let d;
            switch (b) {
                case 3:
                    d = a.left - (this.bl.width + (this.g.as ? this.x : 0));
                    break;
                case 4:
                    d = a.right;
                    break;
                case 0:
                case 2:
                case 1:
                default:
                    switch (c) {
                        case 2:
                            d = a.right - this.bl.width;
                            break;
                        case 3:
                            d = a.right - (a.width / 2) - (this.bl.width / 2);
                            break;
                        case 0:
                        case 1:
                        default:
                            d = a.left;
                            break;
                    }
                    break;
            }
            return d;
        }
        w(a, b, c) {
            let d;
            switch (b) {
                case 3:
                case 4:
                    switch (c) {
                        case 2:
                            d = a.bottom - this.bl.height;
                            break;
                        case 3:
                            d = a.top - (this.bl.height / 2) + (a.height / 2);
                            break;
                        case 0:
                        case 1:
                        default:
                            d = a.top;
                            break;
                    }
                    break;
                case 2:
                    d = a.top - (this.bl.height + (this.g.as ? this.x : 0));
                    break;
                case 0:
                case 1:
                default:
                    d = a.bottom;
                    break;
            }
            return d;
        }
        static ap(a) {
            return stringFormat("{0}px", a);
        }
        static ao(a) {
            return stringFormat("{0}px", a);
        }
        bd() {
            if (this.g.q == 1 || this.g.q == 2) {
                switch (this.g.i) {
                    case 3:
                        this.s = this.aa + (this.p - this.n);
                        break;
                }
            }
            else if (this.g.q == 3 || this.g.q == 4) {
                switch (this.g.i) {
                    case 3:
                        this.t = this.ab + (this.q - this.o);
                        break;
                }
            }
            this.ah.setStyleProperty("transform", "translate(" + this.s + "px, " + this.t + "px) rotate(" + this.r + "deg)");
        }
        au(a, b, c, d) {
            this.p = a;
            this.q = b;
            if (this.g.q == 1 || this.g.q == 2) {
                let e = (window.innerWidth);
                let f = a;
                let g = f + c;
                if (f < 5) {
                    a = 5;
                }
                else if (g > e - 5) {
                    a = f - (g - (e - 5));
                }
            }
            else if (this.g.q == 3 || this.g.q == 4) {
                let h = (window.innerHeight);
                let i = b;
                let j = i + d;
                if (i < 5) {
                    b = 5;
                }
                else if (j > h - 5) {
                    b = i - (j - (h - 5));
                }
            }
            return {
                p0: a,
                p1: b
            };
        }
        bj(a, b, c) {
            let d = this.w(a, b, c);
            let e = this.v(a, b, c);
            let f = this.au(e, d, this.bl.width, this.bl.height);
            e = f.p0;
            d = f.p1;
            this.ba(e, d);
            if (b == 2 || c == 2) {
                let g = 10;
                while (g > 0) {
                    let h = this.w(a, b, c);
                    let i = this.v(a, b, c);
                    let j = this.au(i, h, this.bl.width, this.bl.height);
                    i = j.p0;
                    h = j.p1;
                    if (h == d && i == e) {
                        g = 0;
                        break;
                    }
                    d = h;
                    e = i;
                    this.ba(e, d);
                    g--;
                }
            }
            this.bd();
            return new Rect(0, e, d, this.bl.width, this.bl.height);
        }
        ay() {
            if (this.l) {
                this.ak.setStyleProperty("width", stringEmpty());
                this.ak.setStyleProperty("height", stringEmpty());
                this.ag.setStyleProperty("width", stringEmpty());
                this.ag.setStyleProperty("height", stringEmpty());
                this.bk = new Size(1, this.aj.outerWidth(), this.aj.outerHeight());
                this.k = false;
                this.be();
            }
            else {
                this.k = true;
            }
        }
        ba(a, b) {
            let c = stringFormat("{0}px", a);
            let d = stringFormat("{0}px", b);
            this.ag.setStyleProperty("left", c);
            this.ag.setStyleProperty("top", d);
            this.n = a;
            this.o = b;
        }
        a6(a) {
            if (a == null) {
                this.ad = null;
                if (this.ag != null) {
                    this.ag.unlistenAll();
                }
                return;
            }
            this.ad = a;
            let b = a.rootWrapper;
            this.aw(b);
            this.ad.getPortal(this.aj, "ChildContent", (c) => {
                let comp_ = c.componentRef;
                this.an = comp_;
            }, true);
        }
        be() {
            let a = new Size(1, this.bl.width, this.bl.height);
            if (!this.l || !this.g.av) {
                a.height = 0;
            }
            let b = a.width;
            let c = a.height;
            let d = stringFormat("{0}px", b);
            let e = stringFormat("{0}px", c);
            if (this.g.as) {
                let f = 0;
                let g = 0;
                switch (this.g.s()) {
                    case 2:
                        f = 135;
                        g = -this.z;
                        this.s = b / 2 - this.z;
                        this.t = g;
                        d = stringFormat("{0}px", b);
                        e = stringFormat("{0}px", this.x + c);
                        break;
                    case 1:
                        f = -45;
                        g = this.x - this.z;
                        this.s = b / 2 - this.z;
                        this.t = g;
                        d = stringFormat("{0}px", b);
                        e = stringFormat("{0}px", this.x + c);
                        break;
                    case 3:
                        f = -135;
                        g = this.x - this.z;
                        this.s = g;
                        this.t = c / 2 - this.z;
                        d = stringFormat("{0}px", this.x + b);
                        e = stringFormat("{0}px", c);
                        break;
                    case 4:
                        f = 45;
                        g = -this.z;
                        this.s = g;
                        this.t = c / 2 - this.z;
                        d = stringFormat("{0}px", this.x + b);
                        e = stringFormat("{0}px", c);
                        break;
                }
                this.r = f;
                this.ah.setStyleProperty("transform", "translate(" + this.s + "px, " + this.t + "px) rotate(" + this.r + "deg)");
            }
            if (this.f.ao()) {
                if (this.u == c) {
                    return;
                }
                this.f.bw();
                this.m = true;
                return;
            }
            this.m = false;
            let h = stringFormat("{0}px", b);
            let i = stringFormat("{0}px", c);
            this.ak.setStyleProperty("width", h);
            this.ak.setStyleProperty("height", i);
            this.ag.setStyleProperty("width", d);
            this.ag.setStyleProperty("height", e);
        }
        aw(a) {
            this.al = a;
            this.a3();
        }
        ax(a) {
            this.f = a;
        }
        az() {
        }
        a7() {
            this.aq();
            if (this.g.av) {
                return;
            }
            this.be();
        }
        bc(a) {
            if (this.ag != null) {
                this.ag.setStyleProperty("pointer-events", a ? "auto" : "none");
            }
        }
        bb(a) {
            if (this.ag != null) {
                this.ag.setAttribute("tabindex", a ? "-1" : "");
            }
        }
    }
    PopupView.$t = /*@__PURE__*/ markType(PopupView, 'PopupView');
    return PopupView;
})();
/**
 * @hidden
 */
export let Popup = /*@__PURE__*/ (() => {
    class Popup extends Base {
        get cv() {
            return this.cu;
        }
        get ct() {
            return this.cs;
        }
        get q() {
            return this.p;
        }
        get i() {
            return this.h;
        }
        get a0() {
            return this.az;
        }
        constructor() {
            super();
            this.p = 0;
            this.h = 0;
            this.az = 0;
            this.cu = null;
            this.cs = null;
            this.aa = null;
            this.ab = null;
            this.onClosed = null;
            this.onPopup = null;
            this.propertyChanged = null;
            this.popupMouseEnter = null;
            this.popupMouseLeave = null;
            this.popupGotFocus = null;
            this.popupLostFocus = null;
            this.v = null;
            this.ag = false;
            this.a5 = 50;
            this.ak = true;
            this.n = 0;
            this.a3 = -1;
            this.a2 = Popup.a7;
            this.au = false;
            this.ch = Popup.cq;
            this.cg = Popup.cp;
            this.cf = Popup.co;
            this.ci = null;
            this.aw = 0;
            this.ah = true;
            this.ae = false;
            this.ai = false;
            this.r = 0;
            this.cj = null;
            this.ax = 20;
            this.aj = false;
            this.af = false;
            this.j = null;
            let a = this.u();
            this.v = a;
            a.ax(this);
        }
        b7(a, b, c) {
            if (this.propertyChanged != null) {
                this.propertyChanged(this, new PropertyChangedEventArgs(a));
            }
            this.b9(a, b, c);
        }
        b5() {
            if (this.popupMouseEnter != null) {
                this.popupMouseEnter(this, new MouseEventArgs());
            }
        }
        b6() {
            if (this.popupMouseLeave != null) {
                this.popupMouseLeave(this, new MouseEventArgs());
            }
        }
        b3() {
            if (this.popupGotFocus != null) {
                this.popupGotFocus(this, new FocusEventArgs());
            }
        }
        b4(a) {
            if (this.popupLostFocus != null) {
                this.popupLostFocus(this, ((() => {
                    let $ret = new FocusEventArgs();
                    $ret.a = a;
                    return $ret;
                })()));
            }
        }
        get aq() {
            return this.ag;
        }
        set aq(a) {
            let b = this.ag;
            this.ag = a;
            if (b != this.ag) {
                this.b7("IsFocusable", b, this.ag);
            }
        }
        get a6() {
            return this.a5;
        }
        set a6(a) {
            let b = this.a5;
            this.a5 = a;
            if (b != this.a5) {
                this.b7("AnimationDuration", b, a);
            }
        }
        get al() {
            return this.ak;
        }
        set al(a) {
            let b = this.ak;
            this.ak = a;
            if (b != this.ak) {
                this.b7("AnimationEnabled", b, a);
            }
        }
        get o() {
            return this.n;
        }
        set o(a) {
            let b = this.n;
            this.n = a;
            if (b != this.n) {
                this.b7("AnimationType", enumGetBox(PopupAnimationType_$type, b), enumGetBox(PopupAnimationType_$type, this.n));
            }
        }
        get a8() {
            return this.a3;
        }
        set a8(a) {
            let b = this.a3;
            this.a3 = a;
            if (b != this.a3) {
                this.b7("Elevation", b, a);
            }
        }
        get a4() {
            return this.a2;
        }
        set a4(a) {
            let b = this.a2;
            this.a2 = a;
            if (b != this.a2) {
                this.b7("ActualElevation", b, a);
            }
        }
        get av() {
            return this.au;
        }
        get cm() {
            return this.ch;
        }
        set cm(a) {
            let b = this.ch;
            this.ch = a;
            if (b != this.ch) {
                this.b7("ActualUmbraShadowColor", b, a);
            }
        }
        get cl() {
            return this.cg;
        }
        set cl(a) {
            let b = this.cg;
            this.cg = a;
            if (b != this.cg) {
                this.b7("ActualPenumbraShadowColor", b, a);
            }
        }
        get ck() {
            return this.cf;
        }
        set ck(a) {
            let b = this.cf;
            this.cf = a;
            if (b != this.cf) {
                this.b7("ActualAmbientShadowColor", b, a);
            }
        }
        get cn() {
            return this.ci;
        }
        set cn(a) {
            let b = this.ci;
            this.ci = a;
            if (b != this.ci) {
                this.b7("Background", b, this.ci);
            }
        }
        get ay() {
            return this.aw;
        }
        set ay(a) {
            let b = this.aw;
            this.aw = a;
            if (b != this.aw) {
                this.b7("CornerRadius", b, this.aw);
            }
        }
        get ar() {
            return this.ah;
        }
        set ar(a) {
            let b = this.ah;
            this.ah = a;
            if (b != this.ah) {
                this.b7("IsHitTestVisible", b, this.ah);
            }
        }
        get an() {
            return this.ae;
        }
        set an(a) {
            let b = this.ae;
            this.ae = a;
            if (b != this.ae) {
                this.b7("DisableHitTestDuringAnimation", b, this.ae);
            }
        }
        get as() {
            return this.ai;
        }
        set as(a) {
            let b = this.ai;
            this.ai = a;
            if (b != this.ai) {
                this.b7("IsPointerEnabled", b, this.ai);
            }
        }
        get t() {
            return this.r;
        }
        set t(a) {
            let b = this.r;
            this.r = a;
            if (b != this.r) {
                this.b7("PointerPosition", enumGetBox(PopupPointerPosition_$type, b), enumGetBox(PopupPointerPosition_$type, this.r));
            }
        }
        get cr() {
            return this.cj;
        }
        set cr(a) {
            let b = this.cj;
            this.cj = a;
            if (b != this.cj) {
                this.b7("PointerBackground", b, this.cj);
            }
        }
        get a1() {
            return this.ax;
        }
        set a1(a) {
            let b = this.ax;
            this.ax = a;
            if (b != this.ax) {
                this.b7("PointerSize", b, this.ax);
            }
        }
        get at() {
            return this.aj;
        }
        set at(a) {
            this.aj = a;
        }
        get ap() {
            return this.af;
        }
        set ap(a) {
            this.af = a;
        }
        u() {
            return new PopupView();
        }
        b9(a, b, c) {
            switch (a) {
                case "IsShown":
                    if (false == this.av) {
                        this.v.a9();
                    }
                    break;
                case "Elevation":
                    this.a4 = this.a8 == -1 ? Popup.a7 : this.a8;
                    break;
                case "ActualElevation":
                case "ActualUmbraShadowColor":
                case "ActualPenumbraShadowColor":
                case "ActualAmbientShadowColor":
                case "Background":
                case "CornerRadius":
                    this.v.bi();
                    break;
                case "AnimationEnabled":
                    if (false == this.al) {
                        this.bw();
                    }
                    break;
                case "IsHitTestVisible":
                    this.v.bc(this.ar);
                    break;
                case "IsFocusable":
                    this.v.bb(this.aq);
                    break;
            }
        }
        bw() {
            if (this.ao()) {
                if (null != this.ab && this.ab.playState == 1) {
                    this.ab.cancel();
                }
                if (null != this.aa && this.aa.playState == 1) {
                    this.aa.cancel();
                }
            }
        }
        y(a) {
            let b = this.f(a);
            let c = a ? this.b() : this.a();
            let d = this.v.d(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new TranslateTransform();
            g.k = b.a;
            let h = new TranslateTransform();
            h.k = b.b;
            let i = new AnimationKeyFrameProperty(14, g);
            let j = new AnimationKeyFrameProperty(14, h);
            e.add(i);
            f.add(j);
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        z(a) {
            let b = this.g(a);
            this.v.as(b.h);
            let c = a ? this.b() : this.a();
            let d = this.v.e(c);
            let e = new List$1(AnimationKeyFrameProperty.$, 0);
            let f = new List$1(AnimationKeyFrameProperty.$, 0);
            let g = new AnimationKeyFrameProperty(10, b.g);
            let h = new AnimationKeyFrameProperty(10, b.h);
            e.add(g);
            f.add(h);
            if (this.p == 2) {
                let i = b.c;
                let j = b.f;
                let k = new AnimationKeyFrameProperty(12, i);
                let l = new AnimationKeyFrameProperty(12, j);
                e.add(k);
                f.add(l);
            }
            d.m(...e.toArray());
            d.m(...f.toArray());
            return KeyFrameAnimationFactory.f.c(d);
        }
        a() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.a6;
            a.b = 3;
            return a;
        }
        b() {
            let a = new AnimationKeyFrameEffectTiming();
            a.g = this.a6;
            a.b = 3;
            return a;
        }
        bz() {
            this.v.av();
        }
        f(a) {
            let b = truncate(this.v.bl.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? -b : 0;
            let d = a ? 0 : -b;
            if (this.p == 2) {
                c = 0;
                d = 0;
            }
            let e = ((() => {
                let $ret = new Popup_InnerAnimationInfo();
                $ret.a = c;
                $ret.b = d;
                return $ret;
            })());
            return e;
        }
        g(a) {
            let b = truncate(this.v.bl.height);
            if (b <= 0) {
                b = 500;
            }
            let c = a ? 0 : b;
            let d = a ? b : 0;
            let e = this.cu.top;
            let f = this.cu.top;
            let g = this.cu.left;
            let h = g;
            switch (this.p) {
                case 2:
                    e = a ? this.cu.bottom : this.cu.top;
                    f = a ? this.cu.top : this.cu.bottom;
                    g = this.cu.left;
                    h = g;
                    break;
                case 1:
                    e = this.cu.top;
                    f = this.cu.top;
                    g = this.cu.left;
                    h = g;
                    break;
                case 3:
                case 4:
                    e = this.cu.top;
                    f = e;
                    g = this.cu.left;
                    h = g;
                    break;
            }
            let i = ((() => {
                let $ret = new Popup_OuterAnimationInfo();
                $ret.g = c;
                $ret.h = d;
                $ret.c = e;
                $ret.f = f;
                $ret.a = g;
                $ret.d = h;
                return $ret;
            })());
            return i;
        }
        ao() {
            if (null == this.ab && null == this.aa) {
                return false;
            }
            if (null != this.ab && this.ab.playState == 1) {
                return true;
            }
            if (null != this.aa && this.aa.playState == 1) {
                return true;
            }
            return false;
        }
        b0() {
            this.v.ay();
            if (this.av) {
                this.cu = this.v.bj(this.cs, this.p, this.h);
            }
        }
        b8(a, b, c) {
            this.cs = a;
            this.p = b;
            this.h = c;
            this.az = 0;
            this.v.a7();
            this.cu = this.v.bj(a, b, c);
        }
        cc(a, b, c) {
            if (this.au) {
                this.au = false;
                this.b7("IsShown", true, this.au);
            }
            this.b8(a, b, c);
            this.cd(true);
        }
        cd(a) {
            this.bw();
            let b = this.au;
            this.au = a;
            this.at = a;
            this.ap = !a;
            let c = this.g(a);
            let d = this.f(a);
            if (false == this.al) {
                let e = this.v.ar(c, d);
                c = e.p0;
                d = e.p1;
                return;
            }
            this.bz();
            this.j = this.k(this.o, this.au);
            this.j.d(() => {
                this.j.c();
                this.b7("IsShown", b, this.au);
                if (this.au) {
                    if (this.onPopup != null) {
                        this.onPopup(this, new OnPopupEventArgs());
                    }
                }
                else {
                    if (this.onClosed != null) {
                        this.onClosed(this, new OnClosedEventArgs());
                    }
                }
                this.at = false;
                this.ap = false;
                let f = this.v.ar(c, d);
                c = f.p0;
                d = f.p1;
            });
        }
        k(a, b) {
            switch (a) {
                case 0: return this.m(b);
                case 1: return this.l(b);
                default: return this.m(b);
            }
        }
        m(a) {
            let b = this.y(a);
            let c = this.z(a);
            let d = new PopupAnimation();
            d.a.add(b);
            d.a.add(c);
            return d;
        }
        l(a) {
            let b = this.g(a);
            this.v.as(a ? b.h : b.g);
            let c = this.b();
            let d = this.v.c(c);
            let e = DeviceUtils.g(30);
            let f = this.v.i();
            let g = b.f - e;
            let h = b.f;
            switch (this.p) {
                case 2:
                    g = a ? b.f + e : b.c + e;
                    h = a ? b.f : b.c;
                    f = this.v.i();
                    break;
                case 1:
                    g = b.f - e;
                    h = b.f;
                    f = this.v.i();
                    break;
                case 3:
                    g = b.d + e;
                    h = b.d;
                    f = this.v.h();
                    break;
                case 4:
                    g = b.d - e;
                    h = b.d;
                    f = this.v.h();
                    break;
            }
            d.m(new AnimationKeyFrameProperty(f, a ? g : h));
            d.m(new AnimationKeyFrameProperty(f, a ? h : g));
            let i = this.v.a(c);
            i.m(new AnimationKeyFrameProperty(1, a ? 0 : 1));
            i.m(new AnimationKeyFrameProperty(1, a ? 1 : 0));
            let j = this.v.b(c);
            j.m(new AnimationKeyFrameProperty(10, (a ? b.h : b.g)));
            j.m(new AnimationKeyFrameProperty(10, (a ? b.h : b.g)));
            let k = new PopupAnimation();
            k.a.add(KeyFrameAnimationFactory.f.c(d));
            k.a.add(KeyFrameAnimationFactory.f.c(i));
            k.a.add(KeyFrameAnimationFactory.f.c(j));
            return k;
        }
        contains(a) {
            return this.v.j(a);
        }
        appendPopupContent(a) {
            this.v.at(a);
        }
        removePopupContent(a) {
            this.v.a8(a);
        }
        bx() {
            if (!this.au) {
                return;
            }
            this.cd(false);
        }
        destroy() {
            this.provideRenderer(null);
        }
        showRelativeToExclusionRect(a, b, c) {
            this.cc(a, b, c);
        }
        b1(a) {
            this.cs = a;
            this.cu = this.v.bj(a, this.p, this.h);
        }
        notifySizeChanged() {
        }
        provideRenderer(a) {
            this.v.a6(a);
        }
        a9() {
            return this.c();
        }
        bl() {
            let a = this.c();
            return a.f();
        }
        c() {
            let a = new PopupVisualModelExport();
            a.e = this.a4;
            a.d = this.av;
            a.c = AppearanceHelper.a(this.cm);
            a.b = AppearanceHelper.a(this.cl);
            a.a = AppearanceHelper.a(this.ck);
            return a;
        }
        s() {
            let a = this.t;
            if (a == 0) {
                switch (this.q) {
                    case 4:
                        a = 3;
                        break;
                    case 3:
                        a = 4;
                        break;
                    case 2:
                        a = 2;
                        break;
                    case 1:
                        a = 1;
                        break;
                }
            }
            return a;
        }
    }
    Popup.$t = /*@__PURE__*/ markType(Popup, 'Popup', Base.$, [INotifyPropertyChanged_$type]);
    Popup.a7 = 2;
    Popup.cq = /*@__PURE__*/ BrushUtil.g(66, 0, 0, 0);
    Popup.cp = /*@__PURE__*/ BrushUtil.g(30, 0, 0, 0);
    Popup.co = /*@__PURE__*/ BrushUtil.g(20, 0, 0, 0);
    return Popup;
})();
