import { Base, Type, INotifyPropertyChanged, PropertyChangedEventArgs } from "./type";
import { Size } from "./Size";
import { DomRenderer, DomWrapper } from "./dom";
import { Brush } from "./Brush";
import { PopupPointerPosition } from "./PopupPointerPosition";
import { Popup_OuterAnimationInfo } from "./Popup_OuterAnimationInfo";
import { Popup_InnerAnimationInfo } from "./Popup_InnerAnimationInfo";
import { AnimationKeyFrameEffect } from "./AnimationKeyFrameEffect";
import { AnimationKeyFrameEffectTiming } from "./AnimationKeyFrameEffectTiming";
import { UIElementPropertyId } from "./UIElementPropertyId";
import { Rect } from "./Rect";
import { PopupDirection } from "./PopupDirection";
import { PopupAlignment } from "./PopupAlignment";
import { PopupAnimationType } from "./PopupAnimationType";
import { OnClosedEventArgs } from "./OnClosedEventArgs";
import { MouseEventArgs } from "./MouseEventArgs";
import { FocusEventArgs } from "./FocusEventArgs";
import { OnPopupEventArgs } from "./OnPopupEventArgs";
import { PopupVisualModelExport } from "./PopupVisualModelExport";
/**
 * @hidden
 */
export declare class PopupView extends Base {
    static $t: Type;
    private ad;
    private f;
    private al;
    private ak;
    private aj;
    private ag;
    private ai;
    private ah;
    private an;
    private get ac();
    private get z();
    private get y();
    private get x();
    private get aa();
    private get ab();
    private s;
    private t;
    private r;
    private l;
    private u;
    private p;
    private q;
    private n;
    private o;
    protected get g(): Popup;
    protected get ae(): DomRenderer;
    protected a3(): void;
    bh(): void;
    bf(): void;
    bg(): void;
    bi(): void;
    private a4;
    private a5;
    private a1;
    private a2;
    aq(): void;
    ar(a: Popup_OuterAnimationInfo, b: Popup_InnerAnimationInfo): {
        p0?: Popup_OuterAnimationInfo;
        p1?: Popup_InnerAnimationInfo;
    };
    as(a: number): void;
    a9(): void;
    at(a: any): void;
    private af;
    private am;
    private a0;
    j(a: any): boolean;
    a8(a: any): void;
    d(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    e(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    av(): void;
    c(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    b(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    a(a: AnimationKeyFrameEffectTiming): AnimationKeyFrameEffect;
    i(): UIElementPropertyId;
    h(): UIElementPropertyId;
    private bk;
    get bl(): Size;
    private v;
    private w;
    private static ap;
    private static ao;
    private bd;
    private au;
    bj(a: Rect, b: PopupDirection, c: PopupAlignment): Rect;
    private k;
    ay(): void;
    private ba;
    a6(a: DomRenderer): void;
    private m;
    private be;
    protected aw(a: DomWrapper): void;
    ax(a: Popup): void;
    az(): void;
    a7(): void;
    bc(a: boolean): void;
    bb(a: boolean): void;
}
/**
 * @hidden
 */
export declare class Popup extends Base implements INotifyPropertyChanged {
    static $t: Type;
    private p;
    private h;
    private az;
    private cu;
    private cs;
    private aa;
    private ab;
    get cv(): Rect;
    get ct(): Rect;
    get q(): PopupDirection;
    get i(): PopupAlignment;
    get a0(): number;
    constructor();
    onClosed: (sender: any, args: OnClosedEventArgs) => void;
    onPopup: (sender: any, args: OnPopupEventArgs) => void;
    propertyChanged: (sender: any, e: PropertyChangedEventArgs) => void;
    protected b7(a: string, b: any, c: any): void;
    popupMouseEnter: (sender: any, args: MouseEventArgs) => void;
    popupMouseLeave: (sender: any, args: MouseEventArgs) => void;
    popupGotFocus: (sender: any, args: FocusEventArgs) => void;
    popupLostFocus: (sender: any, args: FocusEventArgs) => void;
    b5(): void;
    b6(): void;
    b3(): void;
    b4(a: any): void;
    v: PopupView;
    private ag;
    get aq(): boolean;
    set aq(a: boolean);
    private a5;
    get a6(): number;
    set a6(a: number);
    private ak;
    get al(): boolean;
    set al(a: boolean);
    private n;
    get o(): PopupAnimationType;
    set o(a: PopupAnimationType);
    private a3;
    get a8(): number;
    set a8(a: number);
    static a7: number;
    private a2;
    get a4(): number;
    set a4(a: number);
    private au;
    get av(): boolean;
    static cq: Brush;
    private ch;
    get cm(): Brush;
    set cm(a: Brush);
    static cp: Brush;
    private cg;
    get cl(): Brush;
    set cl(a: Brush);
    static co: Brush;
    private cf;
    get ck(): Brush;
    set ck(a: Brush);
    private ci;
    get cn(): Brush;
    set cn(a: Brush);
    private aw;
    get ay(): number;
    set ay(a: number);
    private ah;
    get ar(): boolean;
    set ar(a: boolean);
    private ae;
    get an(): boolean;
    set an(a: boolean);
    private ai;
    get as(): boolean;
    set as(a: boolean);
    private r;
    get t(): PopupPointerPosition;
    set t(a: PopupPointerPosition);
    private cj;
    get cr(): Brush;
    set cr(a: Brush);
    private ax;
    get a1(): number;
    set a1(a: number);
    private aj;
    get at(): boolean;
    set at(a: boolean);
    private af;
    get ap(): boolean;
    set ap(a: boolean);
    protected u(): PopupView;
    protected b9(a: string, b: any, c: any): void;
    bw(): void;
    private y;
    private z;
    private a;
    private b;
    private bz;
    private f;
    private g;
    ao(): boolean;
    b0(): void;
    private b8;
    private cc;
    private cd;
    private j;
    private k;
    private m;
    private l;
    contains(a: any): boolean;
    appendPopupContent(a: any): void;
    removePopupContent(a: any): void;
    bx(): void;
    destroy(): void;
    showRelativeToExclusionRect(a: Rect, b: PopupDirection, c: PopupAlignment): void;
    b1(a: Rect): void;
    notifySizeChanged(): void;
    provideRenderer(a: DomRenderer): void;
    a9(): any;
    bl(): string;
    c(): PopupVisualModelExport;
    s(): PopupPointerPosition;
}
